<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Menu"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version 4.1a / November 2013 ==

*/

// ******* handling the presets ***************************************
if ($_POST['action'] == 'save_preset') {
	$query = "INSERT INTO ".$dbPrefix."_mod_menu_custom_sets (id, name, settings) VALUES ('', '".addslashes($_POST['cpoMenuCustom'])."', '".addslashes(serialize($activeModules['Menu']))."')"; 
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

    $message[] = sprintf(__('Custom preset <i>%s</i> was saved!'), addslashes($_POST['cpoMenuCustom']));
}
if ($_GET['preset'] == 'delete') {
	$query = "DELETE FROM ".$dbPrefix."_mod_menu_custom_sets WHERE id=".addslashes($_GET['id']); 
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 
    $message[] = __('The custom preset was successfully deleted!');
}
if ($_GET['preset'] == 'load') {
	$query = "SELECT settings FROM ".$dbPrefix."_mod_menu_custom_sets WHERE id=".addslashes($_GET['id']); 
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);
    $db->next_record();
	$settings = unserialize($db->v('settings'));
    foreach ($settings as $k=>$v) {
        if (is_bool($settings[$k])) {
			$_POST['cpoMenuNew'][$k] = (bool) $settings[$k];
        }
        else $_POST['cpoMenuNew'][$k] = $settings[$k];
	}
	$_POST['go'] = true;
    $message[] = __('The custom preset was successfully loaded as new module settings!');
}

// ******* auto create ********************************************************
if ($_POST['action'] == 'autocreate') {
	$db = new DB;
	$query = "DROP TABLE IF EXISTS ".CPO_NAVTREE.";";
	$db->query($query);
	$query = "CREATE TABLE ".CPO_NAVTREE." ( id int(11) NOT NULL auto_increment, l int(11) NOT NULL default '0', r int(11) NOT NULL default '0', caption varchar(255) NOT NULL default '', rubric_id int(11) NOT NULL default '0', settings text NOT NULL, PRIMARY KEY  (id), KEY l (l), KEY r (r), KEY rubric_id (rubric_id)) TYPE=MyISAM;";
	$db->query($query);
	$query = 'INSERT INTO '.$dbPrefix.'_navtree VALUES ('
		."'1', "
		."'1', "
		."'2', "
		."'root', "
		."'0', "
		."'' "
		.")";
	$db->query($query);
	$db->query('SELECT id, name FROM '.CPO_RUBRIC);
	while ($db->next_record()) {
		$existingRubrics[$db->v('name')] = $db->v('id');
	}
// return;
	$mod_menu_license_type = license($activeModules['Menu']['lkey'],$activeModules['Menu']['mod_id']);
	if (!$mod_menu_license_type) $mod_menu_registered = FALSE;
	// creating
	$navitems = explode("\n",$_POST['cpoMenuNew']['structure']);
	$prevnavitemLevel = 0; // (root)
	$id = 1; // the first one (root)
	foreach ($navitems AS $key => $navitem)  {
		if (trim($navitem)=='') continue;
		$navitemLevel = 1;
		$navitemParts = explode(';',$navitem);
		$itemCaption = trim($navitemParts[0]);
		$itemRubric = trim($navitemParts[1]);
		$itemRubricDir = (trim($navitemParts[2])) ? trim($navitemParts[2]) : '_rubric';
		$itemRubricSecLevel = (trim($navitemParts[3])) ? trim($navitemParts[3]) : 0;
		$itemRubricSource = (trim($navitemParts[4])) ? $existingRubrics[trim($navitemParts[4])] : $activeModules['Menu']['sourceRubric'];
		for ($n=0;$n>=0;$n++)  {
			if ($itemCaption[$n] == '+')  {
				$navitemLevel++;
			} else {
				break 1;
			}
		}
		$itemCaption = substr($itemCaption,$navitemLevel-1);
		if ($mod_menu_registered === FALSE && $id > 15)  {
			$message[] = sprintf(__('Navigation item <em>%s</em> not created due to missing registration!'),
				                 $itemCaption);
			continue;
		}
		
		// add entry
		if ($prevnavitemLevel == $navitemLevel)  {
			$query = 'SELECT r FROM '.CPO_NAVTREE." WHERE id='".addslashes($id)."'";
			DEBUG(1, $query, __FILE__, __LINE__);
			$db = new DB; 
			$db->query($query);
			$db->next_record();
			$rid = $db->v('r');
			if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');
			$query = 'UPDATE '.CPO_NAVTREE." SET l = l+2 WHERE l>'".addslashes($rid)."' ";
			$db->query($query);
			$query = "UPDATE ".CPO_NAVTREE." SET r = r+2 WHERE r>'".addslashes($rid)."' ";
			$db->query($query);
			$query = "INSERT INTO ".CPO_NAVTREE." (l, r, caption) VALUES ('".addslashes($rid+1)."', '".addslashes($rid+2)."', '".$itemCaption."')";
			$db->query($query);
			if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');
			$id++;
            $db->query('SELECT last_insert_id()');
            $db->next_record();
            $navitemLevels[$navitemLevel] = $db->v('last_insert_id()');
		} elseif ($prevnavitemLevel < $navitemLevel)  {
			//adding sublevel
            $query = 'SELECT r FROM '.CPO_NAVTREE." WHERE id='".addslashes($id)."'";
            $_SESSION['SID_navigation_opened'][$prevnavitemID] = true;
            $db = new DB; 
            $db->query($query);
			$db->next_record();
            $rid = $db->v('r');

            // add entry
            if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');
			$query = 'UPDATE '.CPO_NAVTREE." SET l = l+2 WHERE l>'".addslashes($rid)."' ";
			$db->query($query);
			$query = "UPDATE ".CPO_NAVTREE." SET r = r+2 WHERE r>='".addslashes($rid)."' ";
			$db->query($query);
			$query = "INSERT INTO ".CPO_NAVTREE." (l, r, caption) VALUES ('".addslashes($rid)."', '".addslashes($rid+1)."', '".$itemCaption."')";
			$db->query($query);
            if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');
			$id++;
            $db->query('SELECT last_insert_id()');
            $db->next_record();
            $navitemLevels[$navitemLevel] = $db->v('last_insert_id()');
		} elseif ($prevnavitemLevel > $navitemLevel)  {
			//back on last level
			$query = 'SELECT r FROM '.CPO_NAVTREE." WHERE id='".$navitemLevels[$navitemLevel]."'";
			DEBUG(1, $query, __FILE__, __LINE__);
			$db = new DB; 
			$db->query($query);
			$db->next_record();
			$rid = $db->v('r');
			if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');
			$query = 'UPDATE '.CPO_NAVTREE." SET l = l+2 WHERE l>'".addslashes($rid)."' ";
			$db->query($query);
			$query = "UPDATE ".CPO_NAVTREE." SET r = r+2 WHERE r>'".addslashes($rid)."' ";
			$db->query($query);
			$query = "INSERT INTO ".CPO_NAVTREE." (l, r, caption) VALUES ('".addslashes($rid+1)."', '".addslashes($rid+2)."', '".$itemCaption."')";
			$db->query($query);
			if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');
			$id++;
            $db->query('SELECT last_insert_id()');
            $db->next_record();
            $navitemLevels[$navitemLevel] = $db->v('last_insert_id()');
		}
		$message[] = sprintf(__('Navigation item <em>%s</em> created.'),$itemCaption);
		$prevnavitemLevel = $navitemLevel;
		$prevnavitemID = $id;

		if ($_POST['cpoMenuNew']['rubricscreate'] == 'yes')  {
			// automated rubric create
			$RubricName = ($itemRubric) ? $itemRubric : $itemCaption;
			$db->query('SELECT id, name FROM '.CPO_RUBRIC);
			while ($db->next_record()) {
				$existingRubrics[$db->v('name')] = $db->v('id');
			}
			if (array_key_exists($RubricName, $existingRubrics))  {
				$query = "UPDATE ".CPO_NAVTREE." SET rubric_id='".$existingRubrics[$RubricName]."' WHERE id='".addslashes($id)."' ";
				$db->query($query);
			    $message[] = sprintf(__('Rubric <em>%s</em> already exists. Added to navigation.'),$RubricName);
			} else if (substr($itemRubric,0,7)=="http://" || substr($itemRubric,0,3)=="../" || substr($itemRubric,0,1)=="/")  {  // external link
				$externalSettings = array (
					'externalURL'		=> $itemRubric,
					'externalURLTarget'	=> (trim($navitemParts[2])) ? trim($navitemParts[2]) : ''
					);
				$query = "UPDATE ".CPO_NAVTREE." SET rubric_id='0', settings='".serialize($externalSettings)."' WHERE id='".addslashes($id)."' ";
				$db->query($query);
			    $message[] = sprintf(__('External link <em>%s</em> to <em>%s</em> created.'),$itemCaption,$itemRubric);
			} else {
				$autoRubricSettings = array('title'=>$RubricName);
				$moreRubricSettings = explode("\n",$activeModules['Menu']['autorubricsettings']);
				foreach ($moreRubricSettings AS $moreRubricSetting)  {
					$moreRubricSettingParts = explode(':',$moreRubricSetting);
					$autoRubricSettings[trim($moreRubricSettingParts[0])] = trim(substr($moreRubricSetting,strlen(trim($moreRubricSettingParts[0]))+1));
				}
				$query = "INSERT INTO ".CPO_RUBRIC." (directory, name, seclevel, source_rubric_id, settings) VALUES ('".addslashes($itemRubricDir)."','".addslashes($RubricName)."',".addslashes($itemRubricSecLevel).",".addslashes($itemRubricSource).", '".serialize($autoRubricSettings)."') ";
				$db->query($query);
				$db->query('SELECT last_insert_id()');
				$db->next_record();
				$createdRubricID = $db->v('last_insert_id()');
				$query = "INSERT INTO ".CPO_PERMISSION." (user_id, rubric_id, stufe1, stufe2, stufe3, stufe4) VALUES (".$_SESSION['SID_user']['id'].", ".$createdRubricID.", 1, 1, 1, 1) ";
				$db->query($query);
				$allowedTemplates = explode(';',$activeModules['Menu']['allowedTemplates']);
				foreach ($allowedTemplates AS $allowedTemplate)  {
					$query = "INSERT INTO ".CPO_TPL_ASSIGNMENT." (rubric_id, templates_id, c_time, changer) VALUES (".$createdRubricID.", ".trim($allowedTemplate).", '".date('Y-m-d H:i:s')."', 'mod_menu') ";
					$db->query($query);
				}
				$query = "UPDATE ".CPO_NAVTREE." SET rubric_id='".$createdRubricID."' WHERE id='".addslashes($id)."' ";
				$db->query($query);
			    $message[] = sprintf(__('Rubric <em>%s</em> created.'),$RubricName);
			}

		}
	
	
	}
    $message[] = __('Navigation items were created.');
}

// defaults aus template laden
if (isset($_GET['default'])) {
	if (file_exists("templates/" . $_GET['default'] . "/defaults.inc.php"))  {
		include ("templates/" . $_GET['default'] . "/defaults.inc.php");
	} else {
		include ("templates/" . $_GET['default'] . "/template2defaults.inc.php");
	}

	$_POST['cpoMenuNew'] = $activeModules['Menu'];

    foreach ($settings as $k=>$v) {
        if (is_bool($settings[$k])) {
			$_POST['cpoMenuNew'][$k] = (bool) $settings[$k];
        }
        else $_POST['cpoMenuNew'][$k] = $settings[$k];
	}
    $message[] = __('Template is loaded! Please check your settings, especially the menu-type might be not compatible!');

	$_POST['cpoMenuNew']['template_dir'] = $_GET['default'];
	$_POST['go'] = true;
}


// prefix-actions
if (isset($_GET['prefix'])) {
	if ($_GET['prefix'] == 'add')		$num_of_prefixes = count($activeModules['Menu']['prefix']) + 1;
	if ($_GET['prefix'] == 'remove')	$num_of_prefixes = count($activeModules['Menu']['prefix']) - 1;
	for ($pref=0;$pref<$num_of_prefixes;$pref++)  {
		$_POST['cpoMenuNew']['prefix'][$pref] = $activeModules['Menu']['prefix'][$pref];
	}
	$_POST['go'] = true;
}


// Moduleinstellungen speichern (neue Version mit automatischem Einlesen neuer Variablen)
if (isset($_POST['go'])) {
	$new_settings = $_POST;
    foreach ($activeModules['Menu'] as $k=>$v) {
        if (!isset($_POST['cpoMenuNew'][$k])) continue;
        if (is_bool($activeModules['Menu'][$k])) {
            $activeModules['Menu'][$k] = (bool) $_POST['cpoMenuNew'][$k];
        } else {
			$activeModules['Menu'][$k] = $_POST['cpoMenuNew'][$k];
		}
		if (array_key_exists($k, $new_settings['cpoMenuNew'])) unset($new_settings['cpoMenuNew'][$k]);
    }
    foreach ($new_settings['cpoMenuNew'] as $k=>$v) {
		$activeModules['Menu'][$k] = $new_settings['cpoMenuNew'][$k];
	}
    $c_datum = date ("Y-m-d H:i:s", time());
    $query = sprintf(
             "UPDATE ".CPO_MODULES." SET options ="
            ." '%s' WHERE name = 'Menu'", 
            addslashes(serialize($activeModules['Menu']))
    );
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

    $message[] = __('Module settings were updated!');
    
}

// check template placeholders!
	$vert_tpl_check		= false;
	$horiz_tpl_check	= false;
	$multi_nav	= false;
	if(	
		strstr ($activeModules['Menu']['nav_vert'],"<!-- START_MOD_MENU_NAVIGATION -->")
			AND
		strstr ($activeModules['Menu']['nav_vert'],"<!-- START_NAVITEM -->")
			AND
		strstr ($activeModules['Menu']['nav_vert'],"<!-- ENDE_NAVITEM -->")
			AND
		strstr ($activeModules['Menu']['nav_vert'],"<!-- ENDE_MOD_MENU_NAVIGATION -->")
		)
		$vert_tpl_check = true;

	if(	
		strstr ($activeModules['Menu']['nav_horiz'],"<!-- START_MOD_MENU_NAVIGATION -->")
			AND
		strstr ($activeModules['Menu']['nav_horiz'],"<!-- START_NAVITEM -->")
			AND
		strstr ($activeModules['Menu']['nav_horiz'],"<!-- ENDE_NAVITEM -->")
			AND
		strstr ($activeModules['Menu']['nav_horiz'],"<!-- ENDE_MOD_MENU_NAVIGATION -->")
		)
		$horiz_tpl_check = true;
	if ($vert_tpl_check && $horiz_tpl_check)  $multi_nav = true;


$mod_menu_license_type = license($activeModules['Menu']['lkey'],$activeModules['Menu']['mod_id']);
$mod_menu_commerical = ($mod_menu_license_type == 1 || $mod_menu_license_type == 3) ? TRUE : FALSE;
if (!$mod_menu_license_type) {
    $message[] = sprintf(___('This is a not registered version of %1$s with limited functionality. Please contact your %2$sadministrator%3$s.'),
        htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15'),
        '<a href="mailto:'.htmlspecialchars($cpoSystem['admin_email'], ENT_COMPAT, 'ISO-8859-15').'">',
        '</a>'
    );
	$mod_menu_registered = FALSE;
}

?>