<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Menu"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version 4.1a / November 2013 ==

*/

?>

<script type="text/javascript"><!--
var whichColor = '';
//var col_link = '';

function textarea (boxid, link){ 
	var t=document.getElementById(boxid); 
	if(link.innerHTML=='<?php echo __('enlarge'); ?>'){ 
		t.style.height = t.offsetHeight+350+"px"; 
		link.innerHTML='<?php echo __('reduce'); ?>'; 
	} else{ 
		t.style.height = t.offsetHeight-350+"px"; 
		link.innerHTML='<?php echo __('enlarge'); ?>'; 
	} 
} 

//--> </script>

<?php

		printPageHeader(
			__('Automatic menu creation'),
			__('In this view you easily create rubrics with a working navigation.'),
			'http://manual.conpresso4.de/menu/autocreate.htm',
			true,
			'modules'
		);

include(CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/actions.inc.php');
require(CPO_BASEDIR."_include/message.php");


$navLineDivider = '';
$nav=getNavigation();
foreach ($nav AS $navItem)  {
	$loadNavString .= $navLineDivider;
	if ($navItem['navigation']['externalURL'])  {
		$loadNavString .= str_repeat('+', $navItem['level']-1).$navItem['caption'];
		$loadNavString .= ';'.$navItem['navigation']['externalURL'];
		$loadNavString .= ($navItem['navigation']['externalURLTarget']) ? ';'.$navItem['navigation']['externalURLTarget'] : '';
	} else {
		$loadNavString .= str_repeat('+', $navItem['level']-1).$navItem['caption'];
		$loadNavString .= ($navItem['caption'] != $navItem['rubric']['name'] || $navItem['rubric']['directory'] != '_rubric' || $navItem['rubric']['seclevel']) ? ';'.$navItem['rubric']['name'] : '';
		$loadNavString .= ($navItem['rubric']['directory'] != '_rubric' || $navItem['rubric']['seclevel']) ? ';'.$navItem['rubric']['directory'] : '';
		$loadNavString .= ($navItem['rubric']['seclevel']) ? ';'.$navItem['rubric']['seclevel'] : '';
	}
	$navLineDivider = '\n';
}

if (!$menubreak) {

		echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="modulesettings">';
		echo '<input type="hidden" name="go" value="1">';
		echo '<input type="hidden" name="action" value="autocreate">';
		echo '<input type="hidden" name="list" value="options">';
 
// ******** AUTO CREATE ***************
		echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

			echo '<th colspan="2"><span>'.__('Automatic structure creation').'</span></th>';

		echo '</tr></thead><tbody>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Structure:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 100px;" class="text inputwidth" name="cpoMenuNew[structure]" id="structure">'.htmlspecialchars($activeModules['Menu']['structure'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'structure\', this);return false" id="lnk">'.__('enlarge').'</a></br>';
			echo __('Syntax: [+...]Caption[;Rubricname[;RubricDirectory[;Type(1|2)[;Source rubric]]]] + LF</br>or [+...]Caption[;External link[;Target]] + LF</br>(the count of \'+\' determines the level)');
            echo '</br><a href="#" onClick="document.getElementById(\'structure\').value=\''.$loadNavString.'\';return false;">'.__('Get actual navigation').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Create rubrics:');
            echo '</td>';
            echo '<td class="rightrow">';
			$yes_selected = ($activeModules['Menu']['rubricscreate'] == 'yes') ? ' selected="selected"' : '';
			$no_selected  = ($activeModules['Menu']['rubricscreate'] == 'no')  ? ' selected="selected"' : '';
            echo '<select name="cpoMenuNew[rubricscreate]">';
			echo '<option value="yes"'.$yes_selected.'>'.__('yes').'</option>';
			echo '<option value="no"'.$no_selected.'>'.__('no').'</option>';
            echo '</select>';
          echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Auto rubric settings:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 100px;" class="text inputwidth" name="cpoMenuNew[autorubricsettings]" id="autorubricsettings">'.htmlspecialchars($activeModules['Menu']['autorubricsettings'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'autorubricsettings\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
			echo '<td class="leftrow">';
			echo __('Allowed templates:');
			echo '</td>';
			echo '<td class="rightrow">';
			echo '<input type="text" class="text inputwidth" name="cpoMenuNew[allowedTemplates]" value="'.htmlspecialchars($activeModules['Menu']['allowedTemplates'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
			echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Select source rubric:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<select name="cpoMenuNew[sourceRubric]" size="1">';
			echo '<option value="0">'.__('none').'</option>';
			echo '<option value=""> </option>';
			$db->query('SELECT id, name, seclevel '
				.'FROM '.CPO_RUBRIC.' ORDER BY name ASC');
			while ($db->next_record()) {
				$sel = ($db->v('id')==$activeModules['Menu']['sourceRubric']) ? ' selected="selected"' :'';
				echo '<option value="'.$db->v('id').'"'.$sel.'>'.$db->v('name').'</option>';
			}
			echo '</select>';
            echo '</td>';
		echo '</tr>';
if ($mod_menu_registered === FALSE) 
{
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '</td>';
            echo '<td class="rightrow">';
            echo __('<b>Note:</b> This is an unregistered version of the menue-module. The auto create option is limited to 15 items. You need to register to get unlimited auto create!');
          echo '</td>';
		echo '</tr>';
}


		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Start structure creation').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';

		echo '</form>';

}
?>
