<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Menu"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version 4.1a / November 2013 ==

*/

//define('CPO', true);
$navArray = getNavigation();
$num_of_items = count($navArray);
$activeRubric = 'NV';

//print_r($navArray);

$nav_nr = 0;
for ($i=0;$i<$num_of_items;$i++)  {
	$highlight[$nav_nr] = FALSE;
	$parent_key = '';
	if ($navID == $navArray[$i]['id'])  {
		$highlight[$nav_nr]	= ($navArray[$i]['rubric']['id']) ? TRUE : FALSE;
		$activeRubric	= $navArray[$i]['rubric']['id'];
		$actParent		= getParent($navArray, $navArray[$i]['rubric']['id']);
		$act_L			= $navArray[$i]['l'];
		$act_R			= $navArray[$i]['r'];
		$act_Level		= $navArray[$i]['level'];
		for ($p=$i;$p>=0;$p--)  {
			if ($navArray[$p]['level'] == ($activeModules['Menu']['multilanguage'] == 'yes' ? 2 : 1))  {				// Das ist der zugehrige Hauptpunkt
				$main_L			= $navArray[$p]['l'];
				$main_R			= $navArray[$p]['r'];
				$main_rubrik_id = $navArray[$p]['rubric']['id'];
				$main_highlight = $navArray[$p]['rubric']['name'];
				break;
			}
		}
	}
	$nav_element_id[$nav_nr]		= $navArray[$i]['id'];
	$nav_childs[$nav_nr]			= $navArray[$i]['childs'];
	$nav_text[$nav_nr]				= $navArray[$i]['caption'];
	$nav_rubrik[$nav_nr]			= $navArray[$i]['rubric']['name'];
	$nav_rubrik_id[$nav_nr]			= $navArray[$i]['rubric']['id'];
	$nav_rubrik_directory[$nav_nr]	= $navArray[$i]['rubric']['directory'];
	$nav_rubrik_name[$nav_nr]		= $navArray[$i]['rubric']['name'];
	$nav_rubrik_sec[$nav_nr]		= $navArray[$i]['rubric']['seclevel'];
	$nav_external_url[$nav_nr]		= $navArray[$i]['navigation']['externalURL'];
	$nav_target[$nav_nr]			= $navArray[$i]['navigation']['externalURLTarget'];
	$level[$nav_nr]					= $navArray[$i]['level'];
	$l[$nav_nr]						= $navArray[$i]['l'];
	$r[$nav_nr]						= $navArray[$i]['r'];
	$parent[$nav_nr]				= getParent($navArray, $navArray[$i]['rubric']['id']);
		$nav_nr++;
}

$actNavArray = defineActiveNavigationByID($navArray, $navID, 99, 0, true);
//print_r($actNavArray);
$actNavItems = menu_tree_activeByID($navID, $navArray);
//print_r($actNavItems);

?>
