<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Menu"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version 4.1a / November 2013 ==

*/

?>

<script type="text/javascript"><!--
var whichColor = '';
//var col_link = '';


function openDialog(URL, name, width, height, parameters)
{
    // set some defaults if not given
    if (!name)   name   = '';
    if (!width)  width  = screen.width/2;
    if (!height) height = screen.height/2;
    if (!parameters) parameters = 'scrollbars=no, resizable=yes';

    xOffset = (screen.width  - width)/2;
    yOffset = (screen.height - height)/2;

    newwindow = window.open(URL, name, 'width='+width+', height='+height+', top='+yOffset+', left='+xOffset+', '+parameters);
    return newwindow;
}

function pickedColor(color)
{
    if (!color) return;
    eval('document.modulesettings.'+whichColor+'.value="'+color+'";');
    eval('document.modulesettings.'+whichColor+'_show.style.backgroundColor="'+color+'";');
}

function getPickedColor()
{
    return eval(whichColor+'.value;');
}

function colorize()
{
    document.getElementById('a_link_show').style.backgroundColor = document.getElementById('a_link').value;
    document.getElementById('a_visited_show').style.backgroundColor = document.getElementById('a_visited').value;
    document.getElementById('a_active_show').style.backgroundColor = document.getElementById('a_active').value;
    document.getElementById('a_hover_show').style.backgroundColor = document.getElementById('a_hover').value;
    document.getElementById('actual_background_show').style.backgroundColor = document.getElementById('actual_background').value;
    document.getElementById('main_background_show').style.backgroundColor = document.getElementById('main_background').value;
    document.getElementById('sub_background_show').style.backgroundColor = document.getElementById('sub_background').value;
    document.getElementById('actual_hover_show').style.backgroundColor = document.getElementById('actual_hover').value;
    document.getElementById('main_hover_show').style.backgroundColor = document.getElementById('main_hover').value;
    document.getElementById('sub_hover_show').style.backgroundColor = document.getElementById('sub_hover').value;
}

function textarea (boxid, link){ 
	var t=document.getElementById(boxid); 
	if(link.innerHTML=='<?php echo __('enlarge'); ?>'){ 
		t.style.height = t.offsetHeight+350+"px"; 
		link.innerHTML='<?php echo __('reduce'); ?>'; 
	} else{ 
		t.style.height = t.offsetHeight-350+"px"; 
		link.innerHTML='<?php echo __('enlarge'); ?>'; 
	} 
} 

//--> </script>

<?php

		printPageHeader(
			__('Automatic menu'),
			__('In this view you can work on the menu-options and settings.'),
			'http://manual.conpresso4.de/menu/settings.htm',
			true,
			'modules'
		);

include(CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/actions.inc.php');
require_once(CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/inc_menu_function.inc.php');
require(CPO_BASEDIR."_include/message.php");


if ($mod_menu_registered === FALSE) 
{
	$disabled = ' disabled="disabled"';
	$reg_available = ' '.__('(available in the registered version)');
}
if ($mod_menu_commerical === FALSE) 
{
	$non_comm = ' disabled="disabled"';
	$comm_available = ' '.__('(available in the commercial version)');
}

// ******** GENERAL SETTINGS ***************
		echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="modulesettings">';
		echo '<input type="hidden" name="go" value="1">';
		echo '<input type="hidden" name="list" value="options">';
 
		include(CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/license.inc.php');

if (!$menubreak) {

		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Appearence').'</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

if ($mod_menu_registered === FALSE) 
{
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '</td>';
            echo '<td class="rightrow">';
            echo __('<b>Note:</b> This is an unregistered version of the menue-module. The navigation is limited to 15 items. You need to register to get unlimited navigation!');
          echo '</td>';
		echo '</tr>';
}
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Menu type:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<SELECT NAME="cpoMenuNew[nav_type]">';
			if ($activeModules['Menu']['nav_type'] == 0) $select_navtype0 = ' selected="selected"';
			if ($activeModules['Menu']['nav_type'] == 1) $select_navtype1 = ' selected="selected"';
			if ($activeModules['Menu']['nav_type'] == 2) $select_navtype2 = ' selected="selected"';
			if ($activeModules['Menu']['nav_type'] == 3) $select_navtype3 = ' selected="selected"';
			if ($multi_nav) echo '<option value="3" '.$select_navtype3.'>'.__('Horizontales Men und kolabierende (Unter-)Mens').'</option>';
			if ($multi_nav) echo '<option value="1" '.$select_navtype1.'>'.__('Horizontales Men und vertikale (Unter-)Mens').'</option>';
			echo '<option value="0" '.$select_navtype0.'>'.__('Kolabierende Mens (keine horizontale Navigation)').'</option>';
			echo '<option value="2" '.$select_navtype2.'>'.__('Nur vertikales Men ohne kolabierende Eintrge').'</option>';
			echo '</SELECT>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Show closed rubrics:');
            echo '</td>';
            echo '<td class="rightrow">';
 			$yes_selected = '';
			$no_selected = '';
			if ($activeModules['Menu']['show_closed'] == '1')  $yes_selected = ' selected="selected"';
			if ($activeModules['Menu']['show_closed'] == '0')  $no_selected = ' selected="selected"';
            echo '<select name="cpoMenuNew[show_closed]"'.$disabled.'>';
			echo '<option value="1"'.$yes_selected.'>'.__('yes').'</option>';
			echo '<option value="0"'.$no_selected.'>'.__('no').'</option>';
            echo '</select>';
            echo $reg_available;
           echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Multilanguage support:');
            echo '</td>';
            echo '<td class="rightrow">';
 			$yes_selected = '';
			$no_selected = '';
			if ($activeModules['Menu']['multilanguage'] == 'yes')  $yes_selected = ' selected="selected"';
			if ($activeModules['Menu']['multilanguage'] == 'no')  $no_selected = ' selected="selected"';
            echo '<select name="cpoMenuNew[multilanguage]"'.$non_comm.'>';
			echo '<option value="yes"'.$yes_selected.'>'.__('yes').'</option>';
			echo '<option value="no"'.$no_selected.'>'.__('no').'</option>';
            echo '</select>';
            echo $comm_available;
          echo '</td>';
		echo '</tr>';
		$navArray = getNavigation();
		if ($activeModules['Menu']['multilanguage'] == 'yes')  {
			echo '<tr>';
				echo '<td class="leftrow">';
				echo __('Default language:');
				echo '</td>';
				echo '<td class="rightrow">';
				echo '<select name="cpoMenuNew[defaultlanguage]"'.$non_comm.'>';
				echo '<option value="">--'.__('please choose').'--</option>';
				for ($i=0;$i<count($navArray);$i++)  {
					if ($navArray[$i]['level'] != 1) continue;
					$selected = ($navArray[$i]['caption'] == $activeModules['Menu']['defaultlanguage']) ? ' selected="selected"' : '';
					echo '<option value="'.$navArray[$i]['caption'].'"'.$selected.'>'.$navArray[$i]['caption'].'</option>';
				}
				echo '</select>';
				echo $comm_available;
			  echo '</td>';
			echo '</tr>';
			echo '<tr>';
				echo '<td class="leftrow">';
				echo __('Exclude rubrics:');
				echo '</td>';
				echo '<td class="rightrow">';
				echo '<select name="cpoMenuNew[rubrics][]" size="5" multiple="multiple">';
				if ($activeModules['Menu']['rubrics'][0] == '') $nonesel = ' selected="selected"';
				echo '<option value=""'.$nonesel.'>-- '.__('none').' --</option>';
				for ($i=0;$i<count($navArray);$i++)  {
					if ($navArray[$i]['level'] == 1) continue;
					$sel = (@in_array($navArray[$i]['id'],$activeModules['Menu']['rubrics'])) ? ' selected="selected"' :'';
					echo '<option value="'.$navArray[$i]['id'].'"'.$sel.'>'.$navArray[$i]['rubric']['name'].'</option>';
				}
				echo '</select>';
				echo '</td>';
			echo '</tr>';
		}
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Link to rubric:');
            echo '</td>';
            echo '<td class="rightrow">';
 			$name_selected = '';
			$number_selected = '';
			$custom_selected = '';
			if ($activeModules['Menu']['rubric_link'] == 'name')  $name_selected = ' selected="selected"';
			if ($activeModules['Menu']['rubric_link'] == 'number')  $number_selected = ' selected="selected"';
			if ($activeModules['Menu']['rubric_link'] == 'custom')  $custom_selected = ' selected="selected"';
            echo '<select name="cpoMenuNew[rubric_link]">';
			echo '<option value="name"'.$name_selected.'>'.__('rubric name').'</option>';
			echo '<option value="number"'.$number_selected.'>'.__('rubric number').'</option>';
			echo '<option value="custom"'.$custom_selected.'>'.__('customized').'</option>';
            echo '</select>';
           echo '</td>';
		echo '</tr>';
		if ($activeModules['Menu']['rubric_link'] == 'custom')  {
			echo '<tr>';
				echo '<td class="leftrow">';
				echo sprintf(__('Custom Link:'),$pref+1);
				echo '</td>';
				echo '<td class="rightrow">';
				echo '<input type="text" class="text inputwidth" name="cpoMenuNew[custom]" value="'.htmlspecialchars($activeModules['Menu']['custom'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255"><br />';
				echo __('Placeholders: ### NAV_DIR ###, ### NAV_RUBRIC_ID ### and ### NAV_RUBRIC ### (### NAV_RUBRIC ### will be url-encoded)');
				echo '</td>';
			echo '</tr>';
		}
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';


// ******** Menu colors & classes ***************
		echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Colors and classes').'</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Classes:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo 'Main:&nbsp;<input type="text" class="text" name="cpoMenuNew[classes][class_main]" value="'.$activeModules['Menu']['classes']['class_main'].'" size="10">&nbsp;&nbsp;&nbsp;';
            echo 'Sub:&nbsp;<input type="text" class="text" name="cpoMenuNew[classes][class_base]" value="'.$activeModules['Menu']['classes']['class_base'].'" size="10">&nbsp;&nbsp;&nbsp;';
            echo 'Actual:&nbsp;<input type="text" class="text" name="cpoMenuNew[classes][class_highlight]" value="'.$activeModules['Menu']['classes']['class_highlight'].'" size="10">&nbsp;&nbsp;&nbsp;';
            echo 'Header:&nbsp;<input type="text" class="text" name="cpoMenuNew[classes][class_header]" value="'.$activeModules['Menu']['classes']['class_header'].'" size="10">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Links:');
            echo '</td>';
            echo '<td class="rightrow">';

			echo 'link:&nbsp;<input type="text" class="text" id="a_link" name="cpoMenuNew[colors][a_link]" value="'.strtoupper($activeModules['Menu']['colors']['a_link']).'" size="7" onchange="colorize();"><INPUT TYPE="text" class="text" id="a_link_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'a_link\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)">&nbsp;&nbsp;';
			echo 'visited:&nbsp;<input type="text" class="text" id="a_visited" name="cpoMenuNew[colors][a_visited]" value="'.strtoupper($activeModules['Menu']['colors']['a_visited']).'" size="7" onchange="colorize();"><INPUT TYPE="text" class="text" id="a_visited_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'a_visited\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)">&nbsp;&nbsp;';
			echo 'active:&nbsp;<input type="text" class="text" id="a_active" name="cpoMenuNew[colors][a_active]" value="'.strtoupper($activeModules['Menu']['colors']['a_active']).'" size="7" onchange="colorize();"><INPUT TYPE="text" class="text" id="a_active_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'a_active\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)">&nbsp;&nbsp;';
			echo 'hover:&nbsp;<input type="text" class="text" id="a_hover" name="cpoMenuNew[colors][a_hover]" value="'.strtoupper($activeModules['Menu']['colors']['a_hover']).'" size="7" onchange="colorize();"><INPUT TYPE="text" class="text" id="a_hover_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'a_hover\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Item backgrounds:');
            echo '</td>';
            echo '<td class="rightrow">';

			echo 'Actual:&nbsp;<input type="text" class="text" id="actual_background" name="cpoMenuNew[colors][actual_background]" value="'.strtoupper($activeModules['Menu']['colors']['actual_background']).'" size="7" onchange="colorize();"><INPUT TYPE="text" class="text" id="actual_background_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'actual_background\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)">&nbsp;&nbsp;';

			echo 'Main:&nbsp;<input type="text" class="text" id="main_background" name="cpoMenuNew[colors][main_background]" value="'.strtoupper($activeModules['Menu']['colors']['main_background']).'" size="7" onchange="colorize();"><INPUT TYPE="text" class="text" id="main_background_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'main_background\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)">&nbsp;&nbsp;';

			echo 'Sub:&nbsp;<input type="text" class="text" id="sub_background" name="cpoMenuNew[colors][sub_background]" value="'.strtoupper($activeModules['Menu']['colors']['sub_background']).'" size="7" onchange="colorize();"><INPUT TYPE="text" class="text" id="sub_background_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'sub_background\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)">';

			echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Items hovering:');
            echo '</td>';
            echo '<td class="rightrow">';

			echo 'Actual:&nbsp;<input type="text" class="text" id="actual_hover" name="cpoMenuNew[colors][actual_hover]" value="'.strtoupper($activeModules['Menu']['colors']['actual_hover']).'" size="7" onchange="colorize();"><INPUT TYPE="text" class="text" id="actual_hover_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'actual_hover\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)">&nbsp;&nbsp;';

			echo 'Main:&nbsp;<input type="text" class="text" id="main_hover" name="cpoMenuNew[colors][main_hover]" value="'.strtoupper($activeModules['Menu']['colors']['main_hover']).'" size="7" onchange="colorize();"><INPUT TYPE="text" class="text" id="main_hover_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'main_hover\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)">&nbsp;&nbsp;';

			echo 'Sub:&nbsp;<input type="text" class="text" id="sub_hover" name="cpoMenuNew[colors][sub_hover]" value="'.strtoupper($activeModules['Menu']['colors']['sub_hover']).'" size="7" onchange="colorize();"><INPUT TYPE="text" class="text" id="sub_hover_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'sub_hover\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)">';

			echo '</td>';
		echo '</tr>';
		for ($pref=0;$pref<count($activeModules['Menu']['prefix']);$pref++)  {
			echo '<tr>';
				echo '<td class="leftrow">';
				echo sprintf(__('Prefix #%s:'),$pref+1);
				echo '</td>';
				echo '<td class="rightrow">';
				echo '<input type="text" class="text inputwidth" name="cpoMenuNew[prefix]['.$pref.']" value="'.htmlspecialchars($activeModules['Menu']['prefix'][$pref], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
				echo '</td>';
			echo '</tr>';
		}
		echo '<tr>';
			echo '<td class="leftrow">';
			echo __('Prefix actions:');
			echo '</td>';
			echo '<td class="rightrow">';
			echo '<a href="edit.php?list=options&prefix=add">'.__('more prefixes').'</a> / <a href="edit.php?list=options&prefix=remove">'.__('less prefixes').'</a>';
			echo '</td>';
		echo '</tr>';
						
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';

// ******** Template ***************
		echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Template').'</span></th>';

		echo '</tr></thead><tbody>';

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Vertical menu:');
            echo '</td>';
            echo '<td class="rightrow">';
			if ($vert_tpl_check == false) $red_check = ' style="color:red"';
            echo '<textarea style="width: 95%; height: 100px;" class="text inputwidth" name="cpoMenuNew[nav_vert]" id="nav_vert"'.$red_check.'>'.htmlspecialchars($activeModules['Menu']['nav_vert'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'nav_vert\', this);return false" id="lnk">'.__('enlarge').'</a>';
			echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Horizontal menu:');
            echo '</td>';
            echo '<td class="rightrow">';
			if ($horiz_tpl_check == false) $red_check = ' style="color:red"';
            echo '<textarea style="width: 95%; height: 100px;" class="text inputwidth" name="cpoMenuNew[nav_horiz]" id="nav_horiz"'.$red_check.'>'.htmlspecialchars($activeModules['Menu']['nav_horiz'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'nav_horiz\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Level change:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="5" class="text inputwidth" name="cpoMenuNew[levchange]">'.htmlspecialchars($activeModules['Menu']['levchange'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Level end:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="5" class="text inputwidth" name="cpoMenuNew[levend]">'.htmlspecialchars($activeModules['Menu']['levend'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('CSS-styles:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 100px;" class="text inputwidth" name="cpoMenuNew[css]" id="css">'.htmlspecialchars($activeModules['Menu']['css'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'css\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';


		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';


// ************* Login options ****************************************************************		
	if ($activeModules['Menu']['show_closed'] == '0') {
		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Login options');
		echo $reg_available;
		echo '</span></th>';

		echo '</tr></thead><tbody>';
        // }}}
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Login link:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="3" class="text inputwidth" name="cpoMenuNew[login_link]"'.$disabled.'>'.htmlspecialchars($activeModules['Menu']['login_link'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Logout link:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="3" class="text inputwidth" name="cpoMenuNew[logout_link]"'.$disabled.'>'.htmlspecialchars($activeModules['Menu']['logout_link'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '</td>';
		echo '</tr>';

		$query = "SELECT id, usergroup FROM ".CPO_USERGROUPS." ORDER BY usergroup";
		DEBUG(1, $query, __FILE__, __LINE__);
		$db = new DB;
		$db->query($query); 
		while($db->next_record()) {
			$group_id  = $db->v('id');
			$groupname = $db->v('usergroup');
			echo '<tr>';
				echo '<td class="leftrow">';
				echo sprintf(__('Redirect "%s" to:'), $groupname);
				echo '</td>';
				echo '<td class="rightrow">';
				echo rubric_select($group_id,"cpoMenuNew[usergroup][".$group_id."]",$activeModules['Menu']['usergroup'][$group_id],$disabled);
				echo '</td>';
			echo '</tr>';
		}
		echo '<tr>';
			echo '<td class="leftrow">';
			echo sprintf(__('Redirect after logout:'), $groupname);
			echo '</td>';
			echo '<td class="rightrow">';
			echo rubric_select('',"cpoMenuNew[after_logout]",$activeModules['Menu']['after_logout'],$disabled);
			echo '</td>';
		echo '</tr>';
		echo '<tr>';
			echo '<td class="leftrow">';
			echo '&nbsp;';
			echo '</td>';
			echo '<td class="rightrow">';
			echo __('If you want to use the login/logout-redirection you have to use a modified <i>member.php</i>-file in your directories! Please refer to the manual!');
			echo '</td>';
		echo '</tr>';

		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';
	}



// ******* Sitemap ************************************************************************
		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Sitemap');
		echo $reg_available;
		echo '</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Show articles in sitemap:');
            echo '</td>';
            echo '<td class="rightrow">';
			$yes_selected = '';
			$more_selected = '';
			$no_selected = '';
			if ($activeModules['Menu']['sitemap_details'] == 'yes')  $yes_selected = ' selected="selected"';
			if ($activeModules['Menu']['sitemap_details'] == 'more')  $more_selected = ' selected="selected"';
			if ($activeModules['Menu']['sitemap_details'] == 'no')  $no_selected = ' selected="selected"';
            echo '<select name="cpoMenuNew[sitemap_details]"'.$disabled.'>';
			echo '<option value="yes"'.$yes_selected.'>'.__('yes').'</option>';
			echo '<option value="more"'.$more_selected.'>'.__('if more than one article').'</option>';
			echo '<option value="no"'.$no_selected.'>'.__('no').'</option>';
            echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Link points to:');
            echo '</td>';
            echo '<td class="rightrow">';
			$index_selected = '';
			$detail_selected = '';
			if ($activeModules['Menu']['sitemapArticleLink'] == 'index')  $index_selected = ' selected="selected"';
			if ($activeModules['Menu']['sitemapArticleLink'] == 'detail')  $detail_selected = ' selected="selected"';
            echo '<select name="cpoMenuNew[sitemapArticleLink]"'.$disabled.'>';
			echo '<option value="index"'.$index_selected.'>'.__('index page').'</option>';
			echo '<option value="detail"'.$detail_selected.'>'.__('detail page').'</option>';
            echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Sitemap rubric:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="3" class="text inputwidth" name="cpoMenuNew[sitemap_rubric]"'.$disabled.'>'.htmlspecialchars($activeModules['Menu']['sitemap_rubric'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Sitemap article:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="3" class="text inputwidth" name="cpoMenuNew[sitemap_article]"'.$disabled.'>'.htmlspecialchars($activeModules['Menu']['sitemap_article'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
			echo '<td class="leftrow">';
			echo __('Anchor prefix:');
			echo '</td>';
			echo '<td class="rightrow">';
			echo '<input type="text" class="text" name="cpoMenuNew[apre]" value="'.htmlspecialchars($activeModules['Menu']['apre'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255"><br />';
			echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Show rubric articles:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<select name="cpoMenuNew[showArticles]" size="1">';
			$selnone = ($activeModules['Menu']['showArticles']=="none") ? ' selected="selected"' :'';
			$selbefore = ($activeModules['Menu']['showArticles']=="before") ? ' selected="selected"' :'';
			$selafter = ($activeModules['Menu']['showArticles']=="after") ? ' selected="selected"' :'';
			echo '<option value="none"'.$selnone.'>'.__('none').'</option>';
			echo '<option value="before"'.$selbefore.'>'.__('above sitemap').'</option>';
			echo '<option value="after"'.$selafter.'>'.__('below sitemap').'</option>';
			echo '</select>';
            echo '</td>';
		echo '</tr>';

		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';


// ******* FixNav ************************************************************************
		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Static navigation');
		echo $reg_available;
		echo '</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

		if (!is_writeable(CPO_BASEDIR.$activeModules['Menu']['directory'].'/cache/')) {
			echo '<tr>';
				echo '<td class="leftrow">';
				echo __('Warning:');
				echo '</td>';
				echo '<td class="rightrow">';
				echo sprintf(__('The directory %s is not available for writing! You should change the directory rights if you want to use the static navigation.'),
								CPO_BASEDIR.$activeModules['Menu']['directory'].'/cache/');
				echo '</td>';
			echo '</tr>';
		}
		echo '<tr>';
			echo '<td class="leftrow">';
			echo __('Create static navigation for pseudo-external URL:');
			echo '</td>';
			echo '<td class="rightrow">';
			echo '<select name="cpoMenuNew[fixedNav][]" size="5" multiple="multiple">';
			if ($activeModules['Menu']['fixedNav'][0] == '') $nonesel = ' selected="selected"';
			echo '<option value=""'.$nonesel.'>-- '.__('none').' --</option>';
			for ($i=0;$i<count($navArray);$i++)  {
				if (!$navArray[$i]['navigation']['externalURL']) continue;
				$sel = (@in_array($navArray[$i]['id'],$activeModules['Menu']['fixedNav'])) ? ' selected="selected"' :'';
				echo '<option value="'.$navArray[$i]['id'].'"'.$sel.'>['.$navArray[$i]['id'].'] '.$navArray[$i]['caption'].'</option>';
			}
			echo '</select><br />';
			echo sprintf(__('The selected navigation files will be created on the next logout! They are stored in the directory <i>%s</i>, marked with a "v" for "vertical navigation" or an "h" for "horizontal navigation" with a leading number and followed by the file extension.'),
							CPO_BASEDIR.$activeModules['Menu']['directory'].'/cache/');
			echo '</td>';
		echo '</tr>';
		echo '<tr>';
			echo '<td class="leftrow">';
			echo __('File extension:');
			echo '</td>';
			echo '<td class="rightrow">';
			echo '<input type="text" class="text" name="cpoMenuNew[ext]" value="'.htmlspecialchars($activeModules['Menu']['ext'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255"><br />';
			echo '</td>';
		echo '</tr>';

		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';


// ******* Reload Template ************************************************************************
		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Reset to defaults').'</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Template base:');
            echo '</td>';
            echo '<td class="rightrow">';
			$dir="templates/";
			getDirOnlyList($dir,"cpoMenuNew[template_dir]",$activeModules['Menu']['template_dir']); 
			echo '<script language="Javascript" type="text/javascript">';
			echo 'function set_defaults() { ';
			echo 'dir = document.modulesettings.template_selected.value;';
			echo 'if (confirm(\''.__('Do you really want to reset all design settings to the chosen template?').'\')) { ';
			echo 'location.href="edit.php?list=options&default=" + dir; } }';
			echo '</script>';
            echo ' <input type="hidden" name="template_selected" value="'.$activeModules['Menu']['template_dir'].'"><a href="javascript:set_defaults();"><img src="'.BASE_ABS.'_skin/conpresso/pic_mod_active_on.gif" alt="'.__('reload').'" title="'.__('reload').'"></a><BR>'.__('Using the reset option resets all your individual settings to the defaults by reloading the chosen template!');
			echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';

		echo '</form>';

// ******* Custom Presets ************************************************************************
		echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="presets">';
		echo '<input type="hidden" name="action" value="save_preset">';
		echo '<input type="hidden" name="list" value="options">';
		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Custom presets');
        echo $comm_available;
		echo '</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('New custom preset:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<input type="text" class="text" name="cpoMenuCustom" value="" size="30" maxlength="255"'.$non_comm.'>';
            echo '<input type="submit" class="button" value="'.__('Save custom preset').'"'.$non_comm.'>';
			echo '</td>';
		echo '</tr>';
		$query = "SELECT id, name FROM ".$dbPrefix."_mod_menu_custom_sets ORDER BY name";
		DEBUG(1, $query, __FILE__, __LINE__);
		$db = new DB;
		$db->query($query); 
		while($db->next_record()) {
			$preset_id  = $db->v('id');
			$preset_name = $db->v('name');
			echo '<tr>';
				echo '<td class="leftrow">';
				echo '&nbsp;';
				echo '</td>';
				echo '<td class="rightrow">';
				echo '<a href="edit.php?list=options&preset=load&id='.$preset_id.'" onClick="return confirm(\''.__('Do you really want to load this preset?').'\')">';
				echo '<img src="'.BASE_ABS.'_skin/conpresso/pic_mod_active_off.gif" alt="'.__('load custom preset').'" title="'.__('load custom preset').'" align="absmiddle"></a>';
				echo '<a href="edit.php?list=options&preset=delete&id='.$preset_id.'" onClick="return confirm(\''.__('Do you really want to delete this preset?').'\')">';
				echo '<img src="'.BASE_ABS.'_skin/conpresso/pic_del.gif" alt="'.__('delete custom preset').'" title="'.__('delete custom preset').'" align="absmiddle"></a> ';
				echo $preset_name.'<BR>';
				echo '</td>';
			echo '</tr>';
		}

		echo '</tbody></table>';
		echo '</form>';

		echo '<img src="'.BASE_ABS.'_images/transparent.gif" style="background: url(http://www.conpresso4.de/_sig/log.php?module=menu);" />';
?>
<script type="text/javascript"><!--
	colorize();
//--> </script>
<?php
}
?>