<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Menu"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version 4.1a / November 2013 ==

*/

$translation = array(

// Automatic menu 
'Automatic menu'
=> 'Automatisches Men',
'In this view you can work on the menu-options and settings.'
=> 'In dieser Ansicht knnen Sie die Einstellungen und Optionen des automatischen Mens bearbeiten.',
'<b>Note:</b> This is an unregistered version of the menue-module. The navigation is limited to 15 items. You need to register to get unlimited navigation!'
=> '<b>Hinweis:</b> Die ist eine unregistrierte Version des Men-Moduls. Die automatische Navigation ist begrenzt auf 15 Navigationselemente. Sie mssen das Modul registrieren, um eine unbegrenzte Anzahl an Navigationselementen ausgeben zu knnen!',
'Appearence'
=> 'Erscheinungsbild',
'Menu type:'
=> 'Men-Art:',
'Horizontal menu with collapsing vertical submenu'
=> 'Horizontales Men und kolabierende (Unter-)Mens',
'Horizontal menu with vertical submenu (non-collapsing)'
=> 'Horizontales Men und vertikale (Unter-)Mens',
'Collapsing Menu (no horizontal menu)'
=> 'Kolabierende Mens (keine horizontale Navigation)',
'Vertical menu (non collapsing)'
=> 'Nur vertikales Men ohne kolabierende Eintrge',
'Show articles in sitemap:'
=> 'Artikelanzeige in Sitemap:',
'Show external links in sitemap:'
=> 'Anzeige von externen Links in Sitemap:',
'Show closed rubrics:'
=> 'Geschlossene Rubriken anzeigen:',
'Colors and classes'
=> 'Farben und Klassen',
'Classes:'
=> 'Klassen:',
'Links:'
=> 'Links:',
'Item backgrounds:'
=> 'Meneintrag Hintergrund:',
'Items hovering:'
=> 'Meneintrag Hover:',
'Prefix #%s:'
=> 'Prfix Nr. %s:',
'Prefix actions:'
=> 'Prfix Aktionen:',
'more prefixes'
=> 'mehr Prfixe',
'less prefixes'
=> 'weniger Prfixe',
'Vertical menu:'
=> 'Vertikales Men:',
'Horizontal menu:'
=> 'Horizontales Men:',
'Level change:'
=> 'Level Wechsel:',
'Level end:'
=> 'Level Ende:',
'CSS-styles:'
=> 'CSS-Stile:',
'Login options'
=> 'Login Optionen:',
'Login link:'
=> 'Login Link:',
'Logout link:'
=> 'Logout Link:',
'Redirect "%s" to:'
=> '"%s" weiterleiten zu:',
'Redirect after logout:'
=> 'Weiterleitung nach Logout:',
'If you want to use the login/logout-redirection you have to use a modified <i>member.php</i>-file in your directories! Please refer to the manual!'
=> 'Wenn Sie die Login/Logout-Weiterleitung benutzen wollen, mssen sie eine modifizierte <i>member.php</i>-Datei in Ihren Rubriken verwenden! Bitte lesen Sie dazu das Handbuch!',
'Reset to defaults'
=> 'Zurck zu den Voreinstellungen',
'Template base:'
=> 'Vorlage:',
'Using the reset option resets all your individual settings to the defaults by reloading the chosen template!'
=> 'Das Benutzen der Zurckstellung setzt alle Ihre eigenen Einstellungen auf die Vorgaben zurck. Dies geschieht durch Neuladen des gewhlten Verzeichnisses!',
'Do you really want to reset all design settings to the chosen template?'
=> 'Wollen Sie wirklich alle Meneinstellungen mit den gewhlten Vorgaben berschreiben?',
'Template is loaded! Please check your settings, especially the menu-type might be not compatible!'
=> 'Die Voreinstellungen wurden geladen! Prfen Sie bitte Ihre Einstellungen, insbesondere die Men-Art kann fr die gewhlte Vorlage nicht optimal sein!',
'Custom presets'
=> 'Benutzerdefinierte Voreinstellungen',
'New custom preset:'
=> 'Neue Voreinstellung:',
'Save custom preset'
=> 'Voreinstellung speichern',
'Do you really want to load this preset?'
=> 'Wollen Sie diese Voreinstellung wirklich laden?',
'load custom preset'
=> 'Voreinstellungen laden',
'Do you really want to delete this preset?'
=> 'Wollen Sie diese Voreinstellung wirklich lschen?',
'delete custom preset'
=> 'Voreinstellung lschen',
'Custom preset <i>%s</i> was saved!'
=> 'Voreinstellung <i>%s</i> wurde gespeichert!',
'The custom preset was successfully deleted!'
=> 'Die Benutzer-Voreinstellung wurde erfolgreich gelscht',
'The custom preset was successfully loaded as new module settings!'
=> 'Die benutzerdefinierte Voreinstellung wurde erfolgreich als neue Moduleinstellungen geladen!',

'Module settings were updated!'
=> 'Die Moduleinstellungen wurden gespeichert!',
'Link to rubric:'
=> 'Link zur Rubrik:',
'Custom Link:'
=> 'Benutzerdefinierter Link:',
'rubric name'
=> 'Rubrik-Name',
'rubric number'
=> 'Rubrik-Nummer',
'customized'
=> 'benutzerdefiniert',
'customized'
=> 'benutzerdefiniert',
'Placeholders: ### NAV_DIR ###, ### NAV_RUBRIC_ID ### and ### NAV_RUBRIC ### (### NAV_RUBRIC ### will be url-encoded)'
=> 'Platzhalter: ### NAV_DIR ###, ### NAV_RUBRIC_ID ### und ### NAV_RUBRIC ### (### NAV_RUBRIC ### wird URL-codiert)',
'Sitemap article:'
=> 'Sitemap Artikel:',
'This is a not registered version of %1$s with limited functionality. Please contact your %2$sadministrator%3$s.'
=> 'Dies ist eine unregistrierte Version von %1$s mit eingeschrnkter Funktionalitt. Bitte wenden Sie sich an Ihren %2$sAdministrator%3$s.',
'if more than one article'
=> 'wenn mehr als ein Artikel',
'Anchor prefix:'
=> 'Anker Prfix:',
'enlarge'
=> 'vergrern',
'reduce'
=> 'verkleinern',
'Multilanguage support:'
=> 'Mehrsprachigkeit:',
'Default language:'
=> 'Standard-Sprache:',
'please choose'
=> 'bitte whlen',
'Exclude rubrics:'
=> 'Auszuschlieende Rubriken:',
'(available in the registered version)'
=> '(verfgbar in der registrierten Version)',
'(available in the commercial version)'
=> '(verfgbar in der kommerziellen Version)',
'Link points to:'
=> 'Artikellinks verknpfen mit:',
'Sitemap rubric:'
=> 'Sitemap Rubrik:',
'Show rubric articles:'
=> 'Artikel ausgeben:',
'above sitemap'
=> 'oberhalb der Sitemap',
'below sitemap'
=> 'unterhalb der Sitemap',
'index page'
=> 'Index-Seite',
'detail page'
=> 'Detail-Seite',
'english'
=> 'deutsch',



'Static navigation'
=> 'Statische Navigation',
'Create static navigation for pseudo-external URL:'
=> 'Statische Navigation fr pseudo-externe URLs erzeugen:',
'The selected navigation files will be created on the next logout! They are stored in the directory <i>%s</i>, marked with a "v" for "vertical navigation" or an "h" for "horizontal navigation" with a leading number and followed by the file extension.'
=> 'Die gewhlten Rubrik-Navigationen werden beim nchsten Logout erzeugt! Sie werden im Verzeichnis <i>%s</i> gespeichert, gekennzeichnet mit einem "v" fr "vertikale Navigation" oder einem "h" fr "horizontale Navigation" mit vorangestellter Nummer und gefolgt von der Datei-Endung.',
'File extension:'
=> 'Datei-Endung:',
'Warning:'
=> 'Warnung:',
'The directory %s is not available for writing! You should change the directory rights if you want to use the static navigation.'
=> 'Das Verzeichnis %s ist nicht beschreibbar! Sie mssen Schreibrechte erteilen um die statische Navigation benutzen zu knnen.',


// auto create
'Automatic menu creation'
=> 'Automatische Men-Erstellung',
'In this view you easily create rubrics with a working navigation.'
=> 'In dieser Ansicht knnen Sie einfach Rubriken mit einer funktionierenden Navigation erstellen.',
'Automatic structure creation'
=> 'Automatische Struktur-Erstellung',
'Structure:'
=> 'Struktur:',
'Syntax: [+...]Caption[;Rubricname[;RubricDirectory[;Type(1|2)[;Source rubric]]]] + LF</br>or [+...]Caption[;External link[;Target]] + LF</br>(the count of \'+\' determines the level)'
=> 'Syntax: [+...]Beschriftung[;Rubrikname[;Rubrikverzeichnis[;Art(1|2)[;Quell-Rubrik]]]] + LF</br>oder [+...]Beschriftung[;Externer Link[;Target]] + LF</br>(die Anzahl der \'+\' bestimmt die Navigationsebene)',
'Get actual navigation'
=> 'Aktuelle Navigation einlesen',
'Create rubrics:'
=> 'Rubriken erstellen:',
'Auto rubric settings:'
=> 'Einstellungen fr automatische Rubrikerstellung:',
'<b>Note:</b> This is an unregistered version of the menue-module. The auto create option is limited to 15 items. You need to register to get unlimited auto create!'
=> '<b>Hinweis:</b> Die ist eine unregistrierte Version des Men-Moduls. Die automatische Erstellung ist begrenzt auf 15 Navigationselemente. Sie mssen das Modul registrieren, um eine unbegrenzte Anzahl an Navigationselementen erstellen zu knnen!',
'Start structure creation'
=> 'Automatische Erstellung starten',
'Allowed templates:'
=> 'Erlaubte Templates:',
'Select source rubric:'
=> 'Quellrubrik whlen:',
'none'
=> 'keine',
// auto create actions
'Navigation item <em>%s</em> not created due to missing registration!'
=> 'Das Navigationselement <em>%s</em> wurde wegen fehlender Registrierung nicht erstellt!',
'Navigation item <em>%s</em> created.'
=> 'Das Navigationselement <em>%s</em> wurde erstellt!',
'Rubric <em>%s</em> already exists. Added to navigation.'
=> 'Die Rubrik <em>%s</em> besteht bereits und wurde der Navigation hinzugefgt.',
'Rubric <em>%s</em> created.'
=> 'Die Rubrik <em>%s</em> wurde erstellt!',
'Navigation items were created.'
=> 'Die Navigation wurde erstellt.',
'External link <em>%s</em> to <em>%s</em> created.'
=> 'Externer Link <em>%s</em> zu <em>%s</em> wurde erstellt.',
'english'
=> 'deutsch',
'english'
=> 'deutsch',
'english'
=> 'deutsch',





'english'
=> 'deutsch',

'Save module settings'
=> 'Modul-Einstellungen speichern',
'yes'
=> 'ja',
'no'
=> 'nein'
)

?>