<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Menu"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version 4.1a / November 2013 ==

*/

define('CPO', true);

// ----- START GEMEINSAMER TEIL -------------------------------------------------------------------

// the includes ***********************************************************************************
	include(CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/inc_menu_function.inc.php');
	include(CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/inc_build_nav.inc.php');

// defining the output words
	$nav_active_string		=	"active";
	$nav_nonactive_string	=	"nonactive";
	$indentString			=	"\t\t";

// some basics ***********************************************************************************
	$navstring = '';
	$nav_type			=	$activeModules['Menu']['nav_type'];
	$mod_menu_dir		=	$activeModules['Menu']['directory'];
	$tpl_horiz			=	$activeModules['Menu']['nav_horiz'];
	$tpl_vert			=	$activeModules['Menu']['nav_vert'];
	$template_dir		=	$activeModules['Menu']['template_dir'];
	$class_main			=	$activeModules['classes']['class_main'];
	$class_base			=	$activeModules['classes']['class_base'];
	$class_highlight	=	$activeModules['classes']['class_highlight'];
	$class_header		=	$activeModules['classes']['class_header'];
	$shift				=	($activeModules['Menu']['multilanguage'] == 'yes') ? 1 : 0;

// Dieser Lizenzhinweis mu unverndert im Modul verbleiben!
	$menu_license		=	"\n<!-- \n\tConpresso-Men-Modul von M. Rsel http://www.conpresso4.de\n\tDieses Modul unterliegt den beim Download vereinbarten Lizenzbestimmungen!\n-->\n";

// styles definieren
	$navstring .= "\n<!-- Einbinden der editierbaren Link-Styles -->";
	$navstring .= "\n<style type=\"text/css\">\n<!--\n";
	if ($activeModules['Menu']['colors']['a_link'] != '') 
	$navstring .= "a.mod_menu:link { color:".$activeModules['Menu']['colors']['a_link']."; }\n";
	if ($activeModules['Menu']['colors']['a_visited'] != '') 
	$navstring .= "a.mod_menu:visited { color:".$activeModules['Menu']['colors']['a_visited']."; }\n";
	if ($activeModules['Menu']['colors']['a_active'] != '') 
	$navstring .= "a.mod_menu:active { color:".$activeModules['Menu']['colors']['a_active']."; }\n";
	if ($activeModules['Menu']['colors']['a_hover'] != '') 
	$navstring .= "a.mod_menu:hover { color:".$activeModules['Menu']['colors']['a_hover']."; }\n";
	$navstring .= $activeModules['Menu']['css']."\n";
	$navstring .= "-->\n</style>\n";

	$navstring = $menu_license.$navstring.$menu_license;	// hier packen wir alles in eine Variable!
	$navstring = preg_replace("/(\015\012)|(\015)|(\012)/", '<<NEWLINE>>', $navstring);
	$navstring = $indentString.implode("\n".$indentString,explode("<<NEWLINE>>",$navstring));
	$mod_menu_css = $navstring;

	unset ($navstring);

// ----- ENDE GEMEINSAMER TEIL -------------------------------------------------------------------

// ----- START LOGIN -----------------------------------------------------------------------------
if (empty($_SESSION['SID_log_login_id']) || $_GET['action'] == 'logout') {
	if (file_exists('member.php')) {
		$mod_menu_login = 'member.php?rubric='.$_GET['rubric'];
	} else {
		$mod_menu_login = '../_rubric/member.php?rubric='.$_GET['rubric'];
	}
	$mod_menu_login = str_replace("### NAV_LOGIN_LINK ###",	$mod_menu_login, $activeModules['Menu']['login_link']);
} elseif (!empty($_SESSION['SID_log_login_id'])) {
	if (file_exists('member.php')) {
		$mod_menu_login = 'member.php?action=logout&rubric='.$_GET['rubric'];
	} else {
		$mod_menu_login = '../_rubric/member.php?action=logout&rubric='.$_GET['rubric'];
	}
	$mod_menu_login = str_replace("### NAV_LOGOUT_LINK ###",	$mod_menu_login, $activeModules['Menu']['logout_link']);
}

// ----- ENDE LOGIN --------------------------------------------------------------------------------


// ----- START REDIRECT -------------------------------------------------------------------------------
$mod_menu_redirect = CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/inc_redirect.inc.php';
// ----- ENDE REDIRECT --------------------------------------------------------------------------------

// ----- START LANGUAGE REDIRECT -------------------------------------------------------------------------------
$mod_menu_lang_redirect = CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/lang_redirect.inc.php';
// ----- ENDE LANGUAGE REDIRECT --------------------------------------------------------------------------------


// ----- START HORIZONTALE NAVIGATION -----------------------------------------------------------------

if ($activeModules['Menu']['nav_type']==1 OR $activeModules['Menu']['nav_type']==3)  {	// keine Ausfhrung ntig, wenn keine horizontale Navigation gewnscht
	// Hauptnavigation
	for ($i=0;$i<count($nav_rubrik);$i++)  {
		// Navigation berspringen, wenn Menupunkt nicht dargestellt werden soll
		if (@in_array($nav_element_id[$i],$activeModules['Menu']['rubrics'])) continue;
		if ($activeModules['Menu']['rubric_link'] == 'number') $nav_link = "../".$nav_rubrik_directory[$i]."/index.php?rubric=".$nav_rubrik_id[$i];
		if ($activeModules['Menu']['rubric_link'] == 'name') $nav_link = "../".$nav_rubrik_directory[$i]."/index.php?rubric=".urlencode($nav_rubrik[$i]);
		if ($activeModules['Menu']['rubric_link'] == 'custom') $nav_link = str_replace( array('### NAV_DIR ###','### NAV_RUBRIC ###','### NAV_RUBRIC_ID ###'),  array($nav_rubrik_directory[$i],urlencode($nav_rubrik[$i]),$nav_rubrik_id[$i]), $activeModules['Menu']['custom']);
		$target = '';
		if ($nav_external_url[$i] != '')  {
			$nav_link = $nav_external_url[$i];
			$target = ' target="'.$nav_target[$i].'"';
		}
		$class = $activeModules['Menu']['classes']['class_main'];
		$color = $activeModules['Menu']['colors']['main_background'];
		$hover = $activeModules['Menu']['colors']['main_hover'];
		$grfx_id = "2";
//		if (($highlight[$i] OR $main_highlight==$nav_rubrik[$i]) AND !$nav_external_url[$i])  {
		if ($main_highlight==$nav_element_id[$i])  {  // das Elternelement
			$class = $activeModules['Menu']['classes']['class_header'];
			$color = $activeModules['Menu']['colors']['actual_background'];
			$hover = $activeModules['Menu']['colors']['actual_hover'];
			$grfx_id = "3";
		}
		if ($highlight[$i])  {  // das aktive Element selbst
			$class = $activeModules['Menu']['classes']['class_highlight'];
			$color = $activeModules['Menu']['colors']['actual_background'];
			$hover = $activeModules['Menu']['colors']['actual_hover'];
			$grfx_id = "3";
		}
		// Abschluelement (wird fr jeden Eintrag berechnet, aber durch das Workaround am Ende nur das letzte ausgegeben)
		$levend_string = $level[$i]-$shift;
		if ($i==count($nav_rubrik)-1) {
			$levend = $activeModules['Menu']['levend'];
			$levend = str_replace("### NAV_DIR ###",	$mod_menu_dir,	$levend);
			$levend = str_replace("### TEMPL_DIR ###",	$template_dir,	$levend);
			$levend = str_replace("### NAV_END ###",	$levend_string,	$levend);
		}
		// active/nonactive Indikator
		if (is_array($actNavItems)) $active_flag = (in_array($nav_rubrik_id[$i], $actNavItems)) ? $nav_active_string : $nav_nonactive_string ;

		if ($level[$i] == 1 + $shift)  
		{
			$sql_res_array[] = array (
				$nav_text[$i],
				$nav_link, 
				$pre, 
				$color, 
				$level[$i]-1, 
				$grfx_id, 
				$levchange, 
				$levend, 
				$hover, 
				$class, 
				$target, 
				$active_flag
				);
		}
	}
	$replace_array[] = array ("### NAV_TEXT ###",		"0");
	$replace_array[] = array ("### NAV_LINK ###",		"1");
	$replace_array[] = array ("### NAV_PRE ###",		"2");
	$replace_array[] = array ("### NAV_MARK ###",		"3");
	$replace_array[] = array ("### NAV_LEVEL ###",		"4");
	$replace_array[] = array ("### NAV_GRFX_ID ###",	"5");
	$replace_array[] = array ("### NAV_NEXT_LEVEL ###",	"6");
	$replace_array[] = array ("### NAV_END ###",		"7");
	$replace_array[] = array ("### NAV_HOVER ###",		"8");
	$replace_array[] = array ("### NAV_CLASS ###",		"9");
	$replace_array[] = array ("### NAV_TARGET ###",		"10");
	$replace_array[] = array ("### NAV_ACTIVE ###",		"11");
	$parsed = multitemplate_parser ($tpl_horiz, $replace_array, $sql_res_array);
	while (list($zeile, $navigation) = each ($parsed))  $navstring .= $navigation;
	$navstring = str_replace("### NAV_DIR ###",		$mod_menu_dir,		$navstring);
	$navstring = str_replace("### TEMPL_DIR ###",	$template_dir,		$navstring);
	$navstring = str_replace("### NAV_LOGIN ###",	$mod_menu_login,	$navstring);

	$navstring = $menu_license.$navstring.$menu_license;	// hier packen wir alles in eine Variable!
	$navstring = preg_replace("/(\015\012)|(\015)|(\012)/", '<<NEWLINE>>', $navstring);
	$navstring = $indentString.implode("\n".$indentString,explode("<<NEWLINE>>",$navstring));
	$mod_menu_horizontal = $navstring;

	unset ($navstring, $replace_array, $sql_res_array, $temp_array, $parsed, $navigation);
}

// ----- ENDE HORIZONTALE NAVIGATION --------------------------------------------------------------

// ----- START VERTIKALE NAVIGATION ---------------------------------------------------------------

// Hauptnavigation
for ($i=0;$i<count($nav_rubrik);$i++)  {
	// Navigation berspringen, wenn Menupunkt nicht dargestellt werden soll
	if (@in_array($nav_element_id[$i],$activeModules['Menu']['rubrics'])) continue;
	if ($activeModules['Menu']['rubric_link'] == 'number') $nav_link = "../".$nav_rubrik_directory[$i]."/index.php?rubric=".$nav_rubrik_id[$i];
	if ($activeModules['Menu']['rubric_link'] == 'name') $nav_link = "../".$nav_rubrik_directory[$i]."/index.php?rubric=".urlencode($nav_rubrik[$i]);
	if ($activeModules['Menu']['rubric_link'] == 'custom') $nav_link = str_replace( array('### NAV_DIR ###','### NAV_RUBRIC ###','### NAV_RUBRIC_ID ###'),  array($nav_rubrik_directory[$i],urlencode($nav_rubrik[$i]),$nav_rubrik_id[$i]), $activeModules['Menu']['custom']);
	$target = '';
	if ($nav_external_url[$i] != '')  {
		$nav_link = $nav_external_url[$i];
		$target = ' target="'.$nav_target[$i].'"';
	}

// Zwischenstufen bei Levelwechsel
	if ($nav_type==1 OR $nav_type==3)  $shift = ($activeModules['Menu']['multilanguage'] == 'yes') ? 2 : 1 ;	// Einrckung wegen erster Ebene auf Horizontalem Men
	if ($lastlevel != $level[$i] AND $lastlevel)  {
		$levchange_string = ($level[$i]-$shift).'_'.($lastlevel-$shift);
		$levchange = $activeModules['Menu']['levchange'];
		$levchange = str_replace("### NAV_DIR ###",		$mod_menu_dir,		$levchange);
		$levchange = str_replace("### TEMPL_DIR ###",	$template_dir,		$levchange);
		$levchange = str_replace("### NAV_SHIFT ###",	$levchange_string,	$levchange);
	} else {
		$levchange = "";
	}
// Abschluelement (wird fr jeden Eintrag berechnet, aber durch das Workaround am Ende nur das letzte ausgegeben)
		$levend_string = $level[$i]-$shift;
		$levend = $activeModules['Menu']['levend'];
		$levend = str_replace("### NAV_DIR ###",	$mod_menu_dir,	$levend);
		$levend = str_replace("### TEMPL_DIR ###",	$template_dir,	$levend);
		$levend = str_replace("### NAV_END ###",	$levend_string,	$levend);

// Styles und Eigenschaften
		if ($level[$i]==1)  {
			$class = $activeModules['Menu']['classes']['class_main'];
			$color = $activeModules['Menu']['colors']['main_background'];
			$hover = $activeModules['Menu']['colors']['main_hover'];
			$grfx_id = "2";
		} else {
			$class = $activeModules['Menu']['classes']['class_base'];
			$color = $activeModules['Menu']['colors']['sub_background'];
			$hover = $activeModules['Menu']['colors']['sub_hover'];
			$grfx_id = "2";
		}
		if ($main_highlight && $main_highlight==$nav_element_id[$i])  {
			$class = $activeModules['Menu']['classes']['class_header'];
			$color = $activeModules['Menu']['colors']['actual_background'];
			$hover = $activeModules['Menu']['colors']['actual_hover'];
			$grfx_id = "2";
		}
		if ($highlight[$i])  {
			$class = $activeModules['Menu']['classes']['class_highlight'];
			$color = $activeModules['Menu']['colors']['actual_background'];
			$hover = $activeModules['Menu']['colors']['actual_hover'];
			$grfx_id = "3";
		}
// active/nonactive Indikator
		if (is_array($actNavItems)) $active_flag = (in_array($nav_rubrik_id[$i], $actNavItems)) ? $nav_active_string : $nav_nonactive_string ;


// Bauen wir die Arrays fr den Parser *********************************************************************
	$nav_show = false;

// Kolabierende Mens (keine horizontale Navigation) $nav_type=0 *******************************************
	if ($nav_type==0)  {
		if (array_key_exists($nav_element_id[$i], $actNavArray))  $nav_show = true;
		$level_shift = 0;
			
// Horizontales Men und vertikale (Unter-)Mens $nav_type=1 ***********************************************
	} elseif ($nav_type==1)  {
		if ( $main_L < $l[$i] AND $main_R > $r[$i] )	// alle Verwandten (gemeinsamer Hauptpunkt)
		{
			$nav_show = true;
			$level_shift = 1;
		}
// Nur vertikales Men ohne kolabierende Eintrge $nav_type=2 **********************************************
	} elseif ($nav_type==2)  {
			$nav_show = true;
			$level_shift = 0;

// Horizontales Men und kolabierende (Unter-)Mens $nav_type=3 ********************************************
	} elseif ($nav_type==3)  {
		if (array_key_exists($nav_element_id[$i], $actNavArray) && $level[$i] > $shift)  {
			$nav_show = true;
			$level_shift = 1;
		}
	}

// the prefixes ********************************************************************************************
	if ($activeModules['Menu']['multilanguage'] == 'yes')  $level_shift += 1;
	$pre = $activeModules['Menu']['prefix'][$level[$i]-1-$level_shift];

// everthing decided? then go! *****************************************************************************
	if ($nav_show == true)  {
		$temp_array[] = array (			// <= feeding the array! *******************************************
			$nav_text[$i], 
			$nav_link, 
			$pre, 
			$color, 
			$level[$i]-$level_shift, 
			$grfx_id, 
			$levchange, 
			$levend, 
			$hover, 
			$class,
			$target,
			$active_flag
		);
		$lastlevel = $level[$i];
	}
}

// Workaround fr letztes Element (nur die letzte Begrenzung ($levend) wird gebraucht!)
	$nav_items_count = count($temp_array);
	for ($n=0;$n<$nav_items_count;$n++)  {
	$sql_res_array[] = array (
		$temp_array[$n][0],
		$temp_array[$n][1],
		$temp_array[$n][2],
		$temp_array[$n][3],
		$temp_array[$n][4],
		$temp_array[$n][5],
		$temp_array[$n][6],
		(($n<$nav_items_count-1) ? "" : $temp_array[$n][7]),
		$temp_array[$n][8],
		$temp_array[$n][9],
		$temp_array[$n][10],
		$temp_array[$n][11]
		);
	}

if ($nav_items_count>0)  {		// sind berhaupt Meneintrge vorhanden?
	$replace_array[] = array ("### NAV_TEXT ###",		"0");
	$replace_array[] = array ("### NAV_LINK ###",		"1");
	$replace_array[] = array ("### NAV_PRE ###",		"2");
	$replace_array[] = array ("### NAV_MARK ###",		"3");
	$replace_array[] = array ("### NAV_LEVEL ###",		"4");
	$replace_array[] = array ("### NAV_GRFX_ID ###",	"5");
	$replace_array[] = array ("### NAV_NEXT_LEVEL ###",	"6");
	$replace_array[] = array ("### NAV_END ###",		"7");
	$replace_array[] = array ("### NAV_HOVER ###",		"8");
	$replace_array[] = array ("### NAV_CLASS ###",		"9");
	$replace_array[] = array ("### NAV_TARGET ###",		"10");
	$replace_array[] = array ("### NAV_ACTIVE ###",		"11");
	$parsed = multitemplate_parser ($tpl_vert, $replace_array, $sql_res_array);
	while (list($zeile, $navigation) = each ($parsed))  $navstring .= $navigation;
	$navstring = str_replace("### NAV_DIR ###",		$mod_menu_dir,		$navstring);
	$navstring = str_replace("### TEMPL_DIR ###",	$template_dir,		$navstring);
	$navstring = str_replace("### NAV_LOGIN ###",	$mod_menu_login,	$navstring);

	$navstring = $menu_license.$navstring.$menu_license;	// hier packen wir alles in eine Variable!
	$navstring = preg_replace("/(\015\012)|(\015)|(\012)/", '<<NEWLINE>>', $navstring);
	$navstring = $indentString.implode("\n".$indentString,explode("<<NEWLINE>>",$navstring));
	$mod_menu_vertikal = $navstring;

}
unset ($navstring, $nav_text, $nav_link, $pre, $level, $lastlevel, $replace_array, $nav_rubrik, $nav_nr, $sql_res_array, $temp_array, $parsed, $class);

// ----- ENDE VERTIKALE NAVIGATION -------------------------------------------------------------

if (	license($activeModules['Menu']['lkey'],$activeModules['Menu']['mod_id']) != 1 &&
		license($activeModules['Menu']['lkey'],$activeModules['Menu']['mod_id']) != 2 &&
		license($activeModules['Menu']['lkey'],$activeModules['Menu']['mod_id']) != 3 &&
		$activeModules['Menu']['installed']<(time()-90*24*60*60) && 
		!isset($_POST['go']) &&
		@file_exists(CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/producer.inc.php')
	) 
	{
	include(CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/producer.inc.php');
	$message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'),
		htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
	unset ($mod_menu_vertikal,$mod_menu_horizontal,$mod_menu_login,$mod_menu_css,$MOD);
	$menubreak = true;
} else {
	$menubreak = false;
}

// the CPO4.1 PageTemplate-Functions
function cpoPageModMenuVertikal()    { global $mod_menu_vertikal; return $mod_menu_vertikal; }
function cpoPageModMenuHorizontal()  { global $mod_menu_horizontal; return $mod_menu_horizontal; }
function cpoPageModMenuCSS()         { global $mod_menu_css; return $mod_menu_css; }
function cpoPageModMenuLogin()       { global $mod_menu_login; return $mod_menu_login; }
function cpoPageModMenuSitemap()     { global $activeModules; $mute=true; include(CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/sitemap.inc.php'); return $ul_string; }
function cpoPageModMenuClickstream() { global $activeModules; $mute=true; include(CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/clickstream.inc.php'); return $clickstream; }


unset ($num_of_items, $activeRubric, $nav_nr, $highlight, $parent_key, $activeRubric, $actParent, $act_L, $act_R, $act_Level, $main_L, $main_R, $main_rubrik_id, $main_highlight, $nav_element_id, $nav_childs, $nav_text, $nav_rubrik, $nav_rubrik_id, $nav_rubrik_directory, $nav_rubrik_name, $nav_rubrik_sec, $nav_external_url, $nav_target, $level, $l, $r, $parent, $actNavArray, $actNavItems);

?>
